<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Predictores de saltos, IE-0521: Referencia de la Clase bimodal</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Predictores de saltos, IE-0521
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generado por Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Buscar');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Buscar');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Métodos públicos</a> &#124;
<a href="classbimodal-members.html">Lista de todos los miembros</a>  </div>
  <div class="headertitle">
<div class="title">Referencia de la Clase bimodal</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="bimodal_8hpp_source.html">bimodal.hpp</a>&gt;</code></p>
<div class="dynheader">
Diagrama de herencias de bimodal</div>
<div class="dyncontent">
<div class="center"><img src="classbimodal__inherit__graph.png" border="0" usemap="#bimodal_inherit__map" alt="Inheritance graph"/></div>
<map name="bimodal_inherit__map" id="bimodal_inherit__map">
<area shape="rect" id="node2" href="classpredictor.html" title="predictor" alt="" coords="5,5,77,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">significado de colores y flechas</a>]</span></center></div>
<div class="dynheader">
Diagrama de colaboración para bimodal:</div>
<div class="dyncontent">
<div class="center"><img src="classbimodal__coll__graph.png" border="0" usemap="#bimodal_coll__map" alt="Collaboration graph"/></div>
<map name="bimodal_coll__map" id="bimodal_coll__map">
<area shape="rect" id="node2" href="classpredictor.html" title="predictor" alt="" coords="5,5,77,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">significado de colores y flechas</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Métodos públicos</h2></td></tr>
<tr class="memitem:a613728e5fe743586e7ab74d28631f0e9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbimodal.html#a613728e5fe743586e7ab74d28631f0e9">bimodal</a> (int cantbits)</td></tr>
<tr class="separator:a613728e5fe743586e7ab74d28631f0e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07c5fdfe663a3aa8d593205907354cb3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbimodal.html#a07c5fdfe663a3aa8d593205907354cb3">bimodal</a> ()</td></tr>
<tr class="separator:a07c5fdfe663a3aa8d593205907354cb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6dda8d75eed66e5b0367f76728e6fb4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbimodal.html#aa6dda8d75eed66e5b0367f76728e6fb4">~bimodal</a> ()</td></tr>
<tr class="separator:aa6dda8d75eed66e5b0367f76728e6fb4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a205860f650f011ef89d2efb15b62fae3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbimodal.html#a205860f650f011ef89d2efb15b62fae3">imppredic</a> ()</td></tr>
<tr class="separator:a205860f650f011ef89d2efb15b62fae3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab827f332e83a9c8e4c086cb3b63b1ac1"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbimodal.html#ab827f332e83a9c8e4c086cb3b63b1ac1">prediccion</a> (long progctr, char decision)</td></tr>
<tr class="separator:ab827f332e83a9c8e4c086cb3b63b1ac1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classpredictor"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classpredictor')"><img src="closed.png" alt="-"/>&#160;Métodos públicos heredados desde <a class="el" href="classpredictor.html">predictor</a></td></tr>
<tr class="memitem:a941df172254db3b9e8a2d35e4a96ad29 inherit pub_methods_classpredictor"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a941df172254db3b9e8a2d35e4a96ad29">predictor</a> ()</td></tr>
<tr class="separator:a941df172254db3b9e8a2d35e4a96ad29 inherit pub_methods_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77e91f8c0568eef9e714804644bb72ef inherit pub_methods_classpredictor"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a77e91f8c0568eef9e714804644bb72ef">~predictor</a> ()</td></tr>
<tr class="separator:a77e91f8c0568eef9e714804644bb72ef inherit pub_methods_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e7c6a5236780206a9c012350cc48933 inherit pub_methods_classpredictor"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a7e7c6a5236780206a9c012350cc48933">resumen</a> (int s, int tp, int gh, int ph)</td></tr>
<tr class="separator:a7e7c6a5236780206a9c012350cc48933 inherit pub_methods_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a693b1b900ef423fe30830ed76973a41c inherit pub_methods_classpredictor"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a693b1b900ef423fe30830ed76973a41c">salida</a> (long progctr, char result, char pred, string dir)</td></tr>
<tr class="separator:a693b1b900ef423fe30830ed76973a41c inherit pub_methods_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Otros miembros heredados</h2></td></tr>
<tr class="inherit_header pub_attribs_classpredictor"><td colspan="2" onclick="javascript:toggleInherit('pub_attribs_classpredictor')"><img src="closed.png" alt="-"/>&#160;Atributos públicos heredados desde <a class="el" href="classpredictor.html">predictor</a></td></tr>
<tr class="memitem:a8e2d672fbbe6f7e16d12592f8801f39f inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">int *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a8e2d672fbbe6f7e16d12592f8801f39f">t_predictores</a></td></tr>
<tr class="separator:a8e2d672fbbe6f7e16d12592f8801f39f inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c1e9e7e0f463ab18af8229755d52b7e inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a3c1e9e7e0f463ab18af8229755d52b7e">numbits</a></td></tr>
<tr class="separator:a3c1e9e7e0f463ab18af8229755d52b7e inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40ea9fec251f1ff52548581f67f6dc9c inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a40ea9fec251f1ff52548581f67f6dc9c">t_tamano</a></td></tr>
<tr class="separator:a40ea9fec251f1ff52548581f67f6dc9c inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab384ccca87d54dbcf85ddae02fc6267a inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#ab384ccca87d54dbcf85ddae02fc6267a">pc_mask</a></td></tr>
<tr class="separator:ab384ccca87d54dbcf85ddae02fc6267a inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08e296402b83daab316fa4f5f02686b2 inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a08e296402b83daab316fa4f5f02686b2">numbranches</a></td></tr>
<tr class="separator:a08e296402b83daab316fa4f5f02686b2 inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc7378342ef4e20ac7881dbc8bff1e72 inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#abc7378342ef4e20ac7881dbc8bff1e72">tt</a></td></tr>
<tr class="separator:abc7378342ef4e20ac7881dbc8bff1e72 inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96e452119dc7e1c11e6045d2ec11ce8a inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a96e452119dc7e1c11e6045d2ec11ce8a">ft</a></td></tr>
<tr class="separator:a96e452119dc7e1c11e6045d2ec11ce8a inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cb6a35b879350a019dd2e23260d8983 inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a6cb6a35b879350a019dd2e23260d8983">tn</a></td></tr>
<tr class="separator:a6cb6a35b879350a019dd2e23260d8983 inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65bfa951fc76a4f5de411d82b3a3b73c inherit pub_attribs_classpredictor"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a65bfa951fc76a4f5de411d82b3a3b73c">fn</a></td></tr>
<tr class="separator:a65bfa951fc76a4f5de411d82b3a3b73c inherit pub_attribs_classpredictor"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Descripción detallada</h2>
<div class="textblock"><p>La clase bimodal imprementa el predictor bimodal con su método de predicción de saltos particular </p>
</div><h2 class="groupheader">Documentación del constructor y destructor</h2>
<a id="a613728e5fe743586e7ab74d28631f0e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a613728e5fe743586e7ab74d28631f0e9">&#9670;&nbsp;</a></span>bimodal() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bimodal::bimodal </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>cantbits</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>El constructor bimodal lo que hace es crear la tabla BHT con todos los predictores inicializados en cero (SN). </p><dl class="params"><dt>Parámetros</dt><dd>
  <table class="params">
    <tr><td class="paramname">cantbits</td><td>Parámetro s que indica la cantidad de bits para el tamaño de la tabla 2^s </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a07c5fdfe663a3aa8d593205907354cb3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07c5fdfe663a3aa8d593205907354cb3">&#9670;&nbsp;</a></span>bimodal() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bimodal::bimodal </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor por defecto </p>

</div>
</div>
<a id="aa6dda8d75eed66e5b0367f76728e6fb4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa6dda8d75eed66e5b0367f76728e6fb4">&#9670;&nbsp;</a></span>~bimodal()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bimodal::~bimodal </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Destructor por defecto, libera de memoria la tabla apuntada por el puntero bht </p>

</div>
</div>
<h2 class="groupheader">Documentación de las funciones miembro</h2>
<a id="a205860f650f011ef89d2efb15b62fae3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a205860f650f011ef89d2efb15b62fae3">&#9670;&nbsp;</a></span>imppredic()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void bimodal::imppredic </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Función de impresión de estado de predictores </p>

</div>
</div>
<a id="ab827f332e83a9c8e4c086cb3b63b1ac1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab827f332e83a9c8e4c086cb3b63b1ac1">&#9670;&nbsp;</a></span>prediccion()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char bimodal::prediccion </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>progctr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>decision</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Método de predicción bimodal </p><dl class="params"><dt>Parámetros</dt><dd>
  <table class="params">
    <tr><td class="paramname">progctr</td><td>Contador de programa </td></tr>
    <tr><td class="paramname">decision</td><td>Output del salto </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Devuelve</dt><dd>predicción: Variable tipo char que indica la predicción bimodal </dd></dl>

</div>
</div>
<hr/>La documentación para esta clase fue generada a partir del siguiente fichero:<ul>
<li>include/<a class="el" href="bimodal_8hpp_source.html">bimodal.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generado por &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
